extern long double adcval;

extern long double kscval;

class Distribution;

typedef long double (*AdequacyStat)(unsigned int,const long double *,const Distribution &);


typedef char (*AdequacyTest)(unsigned int,const void*,const Distribution &);

AdequacyTest read_adequacy_test(const char*  testname,const Distribution &dist);

AdequacyTest switchtojackknife(AdequacyTest adequacy_test);

AdequacyTest switchtogrouped(AdequacyTest adequacy_test);

void sortedsubsample(unsigned int n,unsigned int x,unsigned int *to);

void sortedsubsample(unsigned int n,const unsigned int *counts,unsigned int x,unsigned int *to);

void sortedjackknife(unsigned int n,unsigned int x,const long double *data,long double *to);

void   sortedjackknife(unsigned int n,const unsigned int *counts,unsigned int x,unsigned int *to);

unsigned int rbinom(unsigned int n,long double p);

unsigned int rbinom_fast(unsigned int n,long double p);
